/*
 * can.h
 *
 *  Created on: 17.03.2012
 *      Author: Frank
 */

#ifndef CAN_H_
#define CAN_H_

#include <util/delay.h>
#include "spi.h"
#include "mcp2515io.h"

#define SPI_WRITE			0x02
#define SPI_READ			0x03
#define SPI_RESET			0xC0
#define SPI_BIT_MODIFY		0x05
#define SPI_RTS 			0x80
#define SPI_READ_RX			0x90
#define SPI_RX_STATUS		0xB0


typedef struct
{
    uint16_t  id;
    uint8_t   rtr;
    uint8_t   length;
    uint8_t   data[8];
} CANMessage;

void init_can();
void mcp2515_write_register( uint8_t adress, uint8_t data);
void can_send_message(CANMessage *p_message);
uint8_t can_get_message(CANMessage *p_message);

#endif /* CAN_H_ */
