/*
 * display.c
 *
 *  Created on: 12.06.2012
 *      Author: Pascal
 */


#include "display.h"




static uint8_t oldKey = 255;													// Alte Tastenbettigung (default)
static uint8_t oldDirection = 255;												// Alte Joystickrichtung (default)
static uint8_t oldMachineSelection = 255;										// Alte Maschinenauswahl (default)





uint8_t initDisplay() {
	uint8_t displayId = 255;
	uint8_t aktMaschine = 255;

	/* Joystick in Nullstellung */
	uint8_t deleteDirection[] = {ESC, R, L, _2_, _0_, _0_, KOMMA, _3_, _0_, KOMMA, _3_, _5_, _0_, KOMMA, _1_, _2_, _0_,KOMMA,LF};

	/* Joysticktasten sind unbettigt */
	uint8_t noTasten[] 		  = {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _6_,      KOMMA,
					             ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _3_, KOMMA, LF};

	displayId = leseDaten();

	if(displayId == ID_BETRIEB_READY) {											// Display ist hochgefahren
		sendeDaten(noTasten);													// Joystick mit unbettigten Tasten anzeigen
		sendeDaten(deleteDirection);											// Keine Joystickbewegung anzeigen
		
		aktMaschine = eeprom_read_byte((uint8_t*)EE_MASCH);	
		sendeMaschinenauswahl(aktMaschine);										// Letzte Maschinenauswahl anzeigen

	} else {
		displayId = 255;														// ID auf definierten Wert setzen
	}
	
	return displayId;
}






/*
// VERURSACHER - allerdings total unlogisch!
*/
uint8_t checkeMaschinenauswahl(uint8_t aktMaschine) {
	uint8_t ret = 0;
	uint8_t maschinen[] = {ID_MASCH32, ID_MASCH33, ID_MASCH34, ID_MASCH35, 
					  	   ID_MASCH36, ID_MASCH52, ID_MASCH53, ID_MASCH54, 
						   ID_MASCH37, ID_MASCH38, ID_MASCH39, ID_MASCH55, 
						   ID_MASCH56};
	uint8_t len = 13;															// ACHTUNG: Bei nderung der Variable "maschinen" bitte auch die "len" ndern
	
	while(maschinen[ret] != aktMaschine) {										// Ist die aktMaschine gefunden --> Gib den Index heraus
		ret++;
		if(ret > len-1) {														// das endet sonst in einer Endlosschleife
			ret = 255;
			break;
		}
	}

	return ret;
}







void sendeMaschinenauswahl(uint8_t dispayId) {

	uint8_t masch32[] = {ESC, M, N, _1_, _5_, _1_, KOMMA, LF};
	uint8_t masch33[] = {ESC, M, N, _1_, _5_, _2_, KOMMA, LF};
	uint8_t masch34[] = {ESC, M, N, _1_, _5_, _3_, KOMMA, LF};
	uint8_t masch35[] = {ESC, M, N, _1_, _5_, _4_, KOMMA, LF};
	uint8_t masch36[] = {ESC, M, N, _1_, _5_, _5_, KOMMA, LF};

	uint8_t masch52[] = {ESC, M, N, _1_, _5_, _6_, KOMMA, LF};
	uint8_t masch53[] = {ESC, M, N, _1_, _5_, _7_, KOMMA, LF};
	uint8_t masch54[] = {ESC, M, N, _1_, _5_, _8_, KOMMA, LF};
	

	uint8_t masch37[] = {ESC, M, N, _1_, _6_, _0_, KOMMA, LF};  
	uint8_t masch38[] = {ESC, M, N, _1_, _6_, _1_, KOMMA, LF};
	uint8_t masch39[] = {ESC, M, N, _1_, _6_, _2_, KOMMA, LF};

	uint8_t masch55[]     = {ESC, M, N, _1_, _6_, _3_, KOMMA, LF};
	uint8_t masch56[] = {ESC, M, N, _1_, _6_, _4_, KOMMA, LF};
		
		
	//if(checkeMaschinenauswahl(dispayId) != 255  &&  oldMachineSelection != dispayId) {	// Ist die gesendete ID eine Maschine? und wurde auch noch nicht angezeigt?
	if(oldMachineSelection != dispayId) {
		
		oldMachineSelection = dispayId;
	
		switch(dispayId)
		{
			case ID_MASCH32:
				sendeDaten(masch32);
				break;
			case ID_MASCH33:
				sendeDaten(masch33);
				break;
			case ID_MASCH34:
				sendeDaten(masch34);
				break;
			case ID_MASCH35:
				sendeDaten(masch35);
				break;
			case ID_MASCH36:
				sendeDaten(masch36);
				break;
			case ID_MASCH52:
				sendeDaten(masch52);
				break;
			case ID_MASCH53:
				sendeDaten(masch53);
				break;
			case ID_MASCH54:
				sendeDaten(masch54);
				break;
			case ID_MASCH37:
				sendeDaten(masch37);
				break;
			case ID_MASCH38:
				sendeDaten(masch38);
				break;
			case ID_MASCH39:
				sendeDaten(masch39);
				break;
			case ID_MASCH55:
				sendeDaten(masch55);
				break;
			case ID_MASCH56:
				sendeDaten(masch56);
				break;
		} 

	}

}








void sendeJoystickbewegung(const struct JOYSTICK* j) {	
	uint8_t vor[] 	  = {ESC, U, I, _2_, _5_, _5_, KOMMA, _3_, _5_, KOMMA, _2_, KOMMA,LF};	// (Pfeil) setzen - #UI 255, 35, PIC_PFEIL_VOR
	uint8_t zurueck[] = {ESC, U, I, _2_, _5_, _5_, KOMMA, _3_, _5_, KOMMA, _3_, KOMMA,LF};
	uint8_t rechts[]  = {ESC, U, I, _2_, _5_, _5_, KOMMA, _3_, _5_, KOMMA, _4_, KOMMA,LF};
	uint8_t links[]   = {ESC, U, I, _2_, _5_, _5_, KOMMA, _3_, _5_, KOMMA, _5_, KOMMA,LF};
	uint8_t deleteDirection[] = {ESC, R, L, _2_, _0_, _0_, KOMMA, _3_, _0_, KOMMA, _3_, _5_, _0_, KOMMA, _1_, _2_, _0_,KOMMA,LF};

	
		if (j->direction == ypos) {
			if(oldDirection != JOY_VOR) {
				sendeDaten(deleteDirection);												// Bereich lschen und mit Hintergrundfarbe fllen
				sendeDaten(vor);															// Bild fr Joystick vor anzeigen
				oldDirection = JOY_VOR;
			}
		} 
		else if (j->direction == yneg) {
			if(oldDirection != JOY_ZURUECK) {
				sendeDaten(deleteDirection);
				sendeDaten(zurueck);
				oldDirection = JOY_ZURUECK;
			}
		}
		else if (j->direction == xneg) {
			if(oldDirection != JOY_LINKS) {
				sendeDaten(deleteDirection);
				sendeDaten(links);
				oldDirection = JOY_LINKS;
			}
		}
		else if (j->direction == xpos) {
			if(oldDirection != JOY_RECHTS) {
				sendeDaten(deleteDirection);
				sendeDaten(rechts);
				oldDirection = JOY_RECHTS;
			}
		} 
		else {
			if(oldDirection != JOY_NULL) {
				sendeDaten(deleteDirection);
				oldDirection = JOY_NULL;
			}
		}
}







void sendeJoysticktasten(const struct JOYSTICK* j) {
	uint8_t deleteTasten[]  = {ESC, R, L, _1_, _5_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _3_, _8_, _0_, KOMMA, _3_, _0_, _0_, KOMMA, LF};
	uint8_t noTasten[] 		= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _6_,      KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _3_, KOMMA, LF};		// Alle Tasten unbettigt

	uint8_t taste1[]      	= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _7_,      KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _3_, KOMMA, LF};		// Taste 1 bettigt, Taste 6 unbettigt
	uint8_t taste2[]      	= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _8_,      KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _3_, KOMMA, LF};		// Taste 2 bettigt, Taste 6 unbettigt
	uint8_t taste3[]      	= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _9_,      KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _3_, KOMMA, LF};		// Taste 3 bettigt, Taste 6 unbettigt
	uint8_t taste4[]      	= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _1_, _0_, KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _3_, KOMMA, LF};
	uint8_t taste5[]      	= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _1_, _1_, KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _3_, KOMMA, LF};
	uint8_t taste6[]      	= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _6_,      KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _2_, KOMMA, LF};		// Taste 6 bettigt, Taste 1-5 unbettigt

  	uint8_t taste16[]     	= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _7_,      KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _2_, KOMMA, LF};		// Taste 1 bettigt, Taste 6 bettigt
  	uint8_t taste26[]     	= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _8_,      KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _2_, KOMMA, LF};		// Taste 2 bettigt, Taste 6 bettigt
  	uint8_t taste36[]     	= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _9_,      KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _2_, KOMMA, LF};		// Taste 3 bettigt, Taste 6 bettigt
  	uint8_t taste46[]     	= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _1_, _0_, KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _2_, KOMMA, LF};
  	uint8_t taste56[]     	= {ESC, U, I, _2_, _3_, _0_, KOMMA, _1_, _2_, _0_, KOMMA, _1_, _1_, KOMMA,
							   ESC, U, I, _2_, _2_, _5_, KOMMA, _2_, _3_, _5_, KOMMA, _1_, _2_, KOMMA, LF};


	if (j->keys & TASTE6 && (j->keys & TASTE1 || j->keys & TASTE2 || j->keys & TASTE3 || j->keys & TASTE4 || j->keys & TASTE5)) {

		if(j->keys & TASTE1 && oldKey != JOY_TASTE_16) {
			sendeDaten(deleteTasten);								// Bereich lschen und mit Hintergrundfarbe fllen
			sendeDaten(taste16);									// Tasten 1 und 6 bettigt
			oldKey = JOY_TASTE_16;
		}

		if(j->keys & TASTE2 && oldKey != JOY_TASTE_26) {
			sendeDaten(deleteTasten);
			sendeDaten(taste26);
			oldKey = JOY_TASTE_26;
		}

		if(j->keys & TASTE3 && oldKey != JOY_TASTE_36) {
			sendeDaten(deleteTasten);
			sendeDaten(taste36);
			oldKey = JOY_TASTE_36;
		}

		if(j->keys & TASTE4 && oldKey != JOY_TASTE_46) {
			sendeDaten(deleteTasten);
			sendeDaten(taste46);
			oldKey = JOY_TASTE_46;
		}

		if(j->keys & TASTE5 && oldKey != JOY_TASTE_56) {
			sendeDaten(deleteTasten);
			sendeDaten(taste56);
			oldKey = JOY_TASTE_56;
		}

	} else if(j->keys & TASTE1 && oldKey != JOY_TASTE_1) {
		sendeDaten(deleteTasten);										// Taste 1 bettigt
		sendeDaten(taste1);
		oldKey = JOY_TASTE_1;

	} else if(j->keys & TASTE2 && oldKey != JOY_TASTE_2) {
		sendeDaten(deleteTasten);
		sendeDaten(taste2);
		oldKey = JOY_TASTE_2;
	
	} else if(j->keys & TASTE3 && oldKey != JOY_TASTE_3) {
		sendeDaten(deleteTasten);
		sendeDaten(taste3);
		oldKey = JOY_TASTE_3;

	} else if(j->keys & TASTE4 && oldKey != JOY_TASTE_4) {
		sendeDaten(deleteTasten);
		sendeDaten(taste4);
		oldKey = JOY_TASTE_4;

	} else if(j->keys & TASTE5 && oldKey != JOY_TASTE_5) {
		sendeDaten(deleteTasten);
		sendeDaten(taste5);
		oldKey = JOY_TASTE_5;

	} else if(j->keys & TASTE6 && oldKey != JOY_TASTE_6) {
		sendeDaten(deleteTasten);
		sendeDaten(taste6);
		oldKey = JOY_TASTE_6;

	} else if(j->keys == 0x00 && oldKey != JOY_TASTE_UNBET){
		sendeDaten(deleteTasten);
		sendeDaten(noTasten);
		oldKey = JOY_TASTE_UNBET;
	}
}

