/*
 * display.h
 *
 *  Created on: 12.06.2012
 *      Author: Pascal
 */
#ifndef DISPLAY_H_
#define DISPLAY_H_




#include "joystick.h"
#include "small_protokoll.h"
#include <avr/eeprom.h>



uint8_t initDisplay();
void    sendeJoysticktasten(const struct JOYSTICK* j);
void    sendeJoystickbewegung(const struct JOYSTICK* j);
void    sendeMaschinenauswahl(uint8_t dispayId);
uint8_t checkeMaschinenauswahl(uint8_t aktMaschine);




/* EEPROM Speicher */
#define EE_MASCH					5						// Speicherplatz fr die aktuelle Maschine



/* Joystick */
#define JOY_NULL					0						// Joystick in Nullposition
#define JOY_VOR						2						// Joystickbewegung nach vor
#define JOY_ZURUECK					3						// Joystickbewegung nach zurck
#define JOY_RECHTS					4						// Joystickbewegung nach rechts
#define JOY_LINKS					5						// Joystickbewegung nach links

#define JOY_TASTE_UNBET				0						// Joystick - keine Taste bettigt
#define JOY_TASTE_1					1						// Joystick Taste 1 bettigt
#define JOY_TASTE_2					2						// Joystick Taste 2 bettigt
#define JOY_TASTE_3					3						// Joystick Taste 3 bettigt
#define JOY_TASTE_4					4						// Joystick Taste 4 bettigt
#define JOY_TASTE_5					5						// Joystick Taste 5 bettigt
#define JOY_TASTE_6					6						// Joystick Taste 6 bettigt
#define JOY_TASTE_16				16						// Joystick Taste 1 und 6 bettigt
#define JOY_TASTE_26				26						// Joystick Taste 2 und 6 bettigt
#define JOY_TASTE_36				36						// Joystick Taste 3 und 6 bettigt
#define JOY_TASTE_46				46						// Joystick Taste 4 und 6 bettigt
#define JOY_TASTE_56				56						// Joystick Taste 5 und 6 bettigt



#define ID_BETRIEB_READY			200						// Betriebsmen wurde vorbereitet - Alle ntigen Infos bereitstellen
#define ID_INGNORE					255						// Nichts unternehmen


/* Sende- Empfangs IDs */
#define ID_MASCH32					32
#define ID_MASCH33					33
#define ID_MASCH34					34
#define ID_MASCH35					35
#define ID_MASCH36					36

#define ID_MASCH52					52
#define ID_MASCH53					53
#define ID_MASCH54					54


#define ID_MASCH37					37
#define ID_MASCH38					38
#define ID_MASCH39					39

#define ID_MASCH55					55
#define ID_MASCH56					56


#endif /* DISPLAY_H_ */
