/*
 * joystick.c
 *
 *  Created on: 26.09.2010
 *      Author: Frank
 */

#include "joystick.h"
static void GetKeys(void);
static void GetJoystickDirection(void);
//static uint8_t getJoystickPWM();


void readJoystick()
{
	Joystick.pos.y = readADC(JOY_Y_ADC);
	Joystick.pos.x = readADC(JOY_X_ADC);
	GetKeys();
	GetJoystickDirection();
}


uint8_t calcPWM()
{
	uint8_t value = 0;
	int16_t tmp = 0;
	switch (Joystick.direction)
	{
		case yneg:
			value = Joystick.pos.y;
			tmp = (Joystick.min_pw - Joystick.max_pw) * (value - Joystick.MIN)
					/ (Joystick.EPSMIN - Joystick.MIN) + Joystick.max_pw;
			break;
		case ypos:
			value = Joystick.pos.y;
			tmp = (Joystick.max_pw - Joystick.min_pw) * (value - Joystick.EPSMAX)
					/ (Joystick.MAX - Joystick.EPSMAX) + Joystick.min_pw;
		break;
		case xneg:
			value = Joystick.pos.x;
			tmp = (Joystick.min_pw - Joystick.max_pw) * (value - Joystick.MIN)
					/ (Joystick.EPSMIN - Joystick.MIN) + Joystick.max_pw;
			break;
		case xpos:
			value = Joystick.pos.x;
			tmp = (Joystick.max_pw - Joystick.min_pw) * (value - Joystick.EPSMAX)
					/ (Joystick.MAX-Joystick.EPSMAX) + Joystick.min_pw;
		break;
		case none:
			return 0;
		break;
	}

	if (tmp > Joystick.MAX) tmp = Joystick.MAX;
	if (tmp < Joystick.MIN) tmp = Joystick.MIN;

	return (uint8_t)tmp;
}


//Ermittelt gedrckte Tasten im Joystick
static void GetKeys()
{
	//Bit 1,2 sind fr AD-Wandler. 3,4 (noch) nicht belegt
	Joystick.keys = PIN_JOY & JOY_BIT_PATTERN;
//	Joystick.slopes ^= Joystick.keys;
}


// Ermittelt, in welche Richtung der Joystick sich bewegt.
static void GetJoystickDirection()
{
	Joystick.direction = none;
#if 1
	if (Joystick.pos.x < Joystick.EPSMIN)
		Joystick.direction = xneg;
	if (Joystick.pos.x > Joystick.EPSMAX)
		Joystick.direction = xpos;
#else

	if (Joystick.pos.x < Joystick.EPSMIN)
		Joystick.direction = xpos;
	if (Joystick.pos.x > Joystick.EPSMAX)
		Joystick.direction = xneg;
#endif
	if (Joystick.pos.y < Joystick.EPSMIN)
		Joystick.direction = yneg;
	if (Joystick.pos.y > Joystick.EPSMAX)
		Joystick.direction = ypos;
}


void initJoystick()
{
#if 0
	Joystick.MIDDLE 	= 127;
	Joystick.THRESHOLD	= 17;											// ALT: Joystick.THRESHOLD	= 12;
	Joystick.MIN 		= 25;
	Joystick.MAX 		= 232;
#else
	Joystick.MIDDLE 	= 128;
//	Joystick.THRESHOLD	= 20;
	Joystick.THRESHOLD	= 13;											// ALT: Joystick.THRESHOLD	= 8;
	Joystick.MIN 		= 20;
	Joystick.MAX 		= 235;
#endif
	Joystick.EPSMIN 	= Joystick.MIDDLE - Joystick.THRESHOLD;
	Joystick.EPSMAX		= Joystick.MIDDLE + Joystick.THRESHOLD;
	Joystick.value		= Joystick.MIDDLE;
	Joystick.pos.x 		= Joystick.MIDDLE;
	Joystick.pos.y		= Joystick.MIDDLE;
	Joystick.max_pw		= 153;
	Joystick.min_pw		= 65;

}
