/*
 * joystick.h
 *
 *  Created on: 26.09.2010
 *      Author: Frank
 *
 * * Anm. Joystick:
 * vor		entspricht	ypos
 * rck					yneg
 * links				xneg
 * rechts				xpos
 */

#ifndef JOYSTICK_H_
#define JOYSTICK_H_

#include <avr/io.h>
#include <inttypes.h>

#include "adc.h"


#define TASTE1		        (1 << PD7)											// 1000 0000
#define TASTE2		        (1 << PD6)											// 0100 0000
#define TASTE3		        (1 << PD5)											// 0010 0000
#define TASTE4		        (1 << PD4)											// 0001 0000
#define TASTE5		        (1 << PD3)											// 0000 1000
#define TASTE6		        (1 << PD2)											// 0000 0100


#define PIN_JOY				PIND
#define JOY_BIT_PATTERN		(TASTE1|TASTE2|TASTE3|TASTE4|TASTE5|TASTE6)			// 1111 1100


#define JOY_Y_ADC			6
#define JOY_X_ADC			5

struct POINT{
	uint8_t x;
	uint8_t y;
};

typedef struct POINT Point;


void readJoystick();
void initJoystick(void);
uint8_t calcPWM(void);

typedef enum Direction{none, xpos, xneg, ypos, yneg}	Direction;

struct JOYSTICK
{
	Point pos;
	uint8_t MIDDLE;				// Mittelposition
	uint8_t MAX;				// Spannung im max Anschlag
	uint8_t MIN;				//		"	 " min    "
	uint8_t THRESHOLD;			// Ansprechwert des Joysticks
	uint8_t EPSMIN;
	uint8_t EPSMAX;
	uint8_t keys;				// gedrckte Tastenkombination
	uint8_t max_pw;
	uint8_t min_pw;

//	uint8_t slopes;				// Tastenflanke
	Direction direction;		//Richtung
	volatile uint8_t value;		//Aktueller Wert des Joysticks.Wird berechnet von SetJoystick()
}Joystick;


#endif /* JOYSTICK_H_ */
