/*
 * komfort_main.c
 *
 *  Created on: 06.04.2012
 *      Author: Frank
 */

#include "komfort_main.h"


//Datenpaket fuer CAN-Bus
static CANMessage message;




void sendCanMsg(union MSG* msg)
{
	uint8_t i = 0;
	message.id = 1;
    message.rtr = 0; 
	message.length = MSG_LEN;
	for (i = 0; i < MSG_LEN; ++i)
		message.data[i] = msg->data[i];
	can_send_message(&message);
}



ISR(TIMER1_COMPA_vect)
{
	event++; //Erzeuge event in Software
}



void init()
{
	/*** Initialisierung fuer Atmega16 ***/

	DDRA = 0x00;
	DDRB = (1 << PB3) | (1 << MOSI) | (1 << SS) | (1 << SCK);
	DDRC = 0xFF;	
	DDRD = 0x00;

	/** Timer0 PWM **/
	/*
	TCCR0 = 1 << WGM00;						// Phase correct PWM
	TCCR0 |= (1 << COM01);					// Set OC0 on counting up
	TCCR0 |= (1 << CS02) ;					// fpwm = fcpu / 256
*/

	TCCR1B = (1 << WGM12);
	TCCR1B |= (1 << CS11) | (1 << CS10);	// Prozessortakt / 64	-->		16MHz / 64 = 250kHz		-->	0,0000004 sec	
	OCR1A = 125;							// Vergleichsregister	--> alle 0,0000004 sec * 125 = 0,0004 sec wird der Timer aktiviert

	TIMSK = (1 << OCIE1A);					// Aktiviert den Output Compare Interrupt,der ausgelst wird, 
											// wenn das TCNTx Register mit den Wert des OCRx Registers bereinstimmt

	init_adc();
	init_uart();
	initSPI();
	init_can();
	initJoystick();
	initSmall_Protokoll();
	//i2c_init();

	Prog = NONE;


//	message.id = 1;
    message.rtr = 0;
	message.length = MSG_LEN;
	sei();									// Interrupts aktivieren



	uint8_t initId = 255;

	while(initId != ID_BETRIEB_READY) {		// Warten auf Displayfreigabe
		if(event == 10) {
			event = 0;
			initId = initDisplay();
		}
	}

}






int main(void)
{
	//Hardware Initialisierungen
	init();

	union MSG msg;


	//Prog = KOMFORT;
	//Prog = PROG1;
	Prog = PROG2;
	//Prog = PROG3;


	for (;;)
	{
		// 5ms
		if (event == 10)
		{
			event = 0;

			/* Joystick lesen */
			readJoystick();


			/*IO Werte verarbeiten*/
			switch(Prog)
				{
				case PROG1:
					program1(&Joystick, &msg);
					break;
				case PROG2:
					program2(&Joystick, &msg);
					break;
				case PROG3:
					//program3(&Joystick, &msg);
					//break;
				default:
					break;
				}

				/*CAN msg schicken*/
				sendCanMsg(&msg);
			}

			/* Joysticktasten am Display anzeigen */
			sendeJoysticktasten(&Joystick);

			/* Joystickbewegung am Display anzeigen */
			sendeJoystickbewegung(&Joystick);

			/* Maschinenauswahl am Display anzeigen */
			sendeMaschinenauswahl(ID_MASCH34);
		}
}
