/*
 * mcp2515io.h
 *
 *  Created on: 17.03.2012
 *      Author: Frank
 *
 *      defines aus Registermap datasheet mpc2515
 */

#ifndef MCP2515IO_H_
#define MCP2515IO_H_

//IO Control-Register
#define BFPCTRL 	0x0C
#define TXRTSCTRL 	0x0D
#define CANSTAT 	0x0E
#define CANCTRL 	0x0F
#define TEC 		0x1C
#define REC 		0x1D
#define CNF3 		0x28
#define CNF2 		0x29
#define CNF1 		0x2A
#define CANINTE 	0x2B
#define CANINTF 	0x2C
#define EFLG 		0x2D
#define TXB0CTRL 	0x30
#define TXB1CTRL 	0x40
#define TXB2CTRL 	0x50
#define RXB0CTRL 	0x60
#define RXB1CTRL 	0x70


/*
 *
 * Bits in Registern
 *
 * */


//BFPCTRL Bits
#define B1BFS 		5
#define B0BFS 		4
#define B1BFE 		3
#define B0BFE 		2
#define B1BFM 		1
#define B0BFM 		0

//TXRTSCTRL
#define B2RTS 		5
#define B1RTS 		4
#define B0RTS 		3
#define B2RTSM 		2
#define B1RTSM 		1
#define B0RTSM 		0

//CANSTAT
#define OPMOD2 		7
#define OPMOD1 		6
#define OPMOD0 		5
#define ICOD2 		3
#define ICOD1 		2
#define ICOD0 		1

//CANCTRL
#define REQOP2 		7
#define REQOP1 		6
#define REQOP0 		5
#define ABAT 		4
#define OSM 		3
#define CLKEN 		2
#define CLKPRE1 	1
#define CLKPRE0 	0


//cnf3
#define SOF 		7
#define WAKFIL 		6
#define PHSEG22 	2
#define PHSEG21 	1
#define PHSEG20		0

//cnf2
#define BTLMODE 	7
#define SAM 		6
#define PHSEG12 	5
#define PHSEG11		4
#define PHSEG10		3
#define PRSEG2 		2
#define PRSEG1		1
#define PRSEG0		0

//cnf1
#define SJW1 		7
#define SJW0 		6
#define BRP5 		5
#define BRP4 		4
#define BRP3 		3
#define BRP2 		2
#define BRP1 		1
#define BRP0		0

//caninte
#define MERRE 		7
#define WAKIE 		6
#define ERRIE 		5
#define TX2IE 		4
#define TX1IE 		3
#define TX0IE 		2
#define RX1IE 		1
#define RX0IE 		0

//canintf
#define MERRF 		7
#define WAKIF 		6
#define ERRIF 		5
#define TX2IF 		4
#define TX1IF 		3
#define TX0IF 		2
#define RX1IF 		1
#define RX0IF 		0

//eflg
#define RX1OVR 		7
#define RX0OVR 		6
#define TXBO 		5
#define TXEP 		4
#define RXEP 		3
#define TXWAR 		2
#define RXWAR 		1
#define EWARN 		0

//TXB0CTRL
#define ABTF 		6
#define MLOA 		5
#define TXERR 		4
#define TXREQ 		3
#define TXP1 		1
#define TXP0 		0


//TXB1CTRL

#define ABTF 		6
#define MLOA 		5
#define TXERR 		4
#define TXREQ 		3
#define TXP1 		1
#define TXP0 		0

//TXB2CTRL/
#define ABTF 		6
#define MLOA 		5
#define TXERR 		4
#define TXREQ 		3
#define TXP1 		1
#define TXP0 		0


//RXB0CTRL
#define RXM1 		6
#define RXM0 		5
#define RXRTR 		3
#define BUKT1 		2
#define BUKT0 		1
#define FILHIT0 	0

//RXB1CTRL
#define RSM1 		6
#define RXM0 		5
#define RXRTR 		3
#define FILHIT2 	2
#define FILHIT1 	1
#define FILHIT0 	0


//Filter & Bitmasken
#define RXM0SIDH	0x20
#define RXM0SIDL 	0x21
#define RXM0EID8 	0x22 //ok
#define RXM0EID0	0x23 //ok

#define RXM1SIDH	0x24
#define RXM1SIDL 	0x25
#define RXM1EID8	0x26 //ok
#define RXM1EID0	0x27 //Ok



//Datenregister. CAN Buffer, Header, etc
#define TXB0D0		0x36
#define TXB0DLC 	0x35
#define TXB0SIDH	0x31
#define TXB0SIDL	0x32

//Bits in Datenregistern
#define RTR 		6
#endif /* MCP2515IO_H_ */
