/*
 * program1.c
 *
 *  Created on: 07.04.2012
 *      Author: Frank
 */

#include <inttypes.h>
#include "msg.h"
#include "joystick.h"


static uint16_t out = 0;
static uint8_t pwm = 0;
static uint16_t delaySW = 0;							// Verzgerung fr SW-Ventile


static void noKeys(const struct JOYSTICK* j)
{
	// VOR
	if (j->direction == ypos) 
	{
		out  |= (1 << 1) | (1 << 2);
		pwm = 2;										// PWM2 Pin 11
		delaySW = 0;
	}

	// ZURCK
	else if (j->direction == yneg)
	{
		if(delaySW >= 20) {								// Verzgerung fr SW-Ventile (5ms x 20 = 100ms)
			out  |= (1 << 1) | (1 << 2);
		}
		pwm = 1;										// PWM1 Pin 13
		delaySW++;
	}

	// LINKS
	else if (j->direction == xneg)
	{
		out  |= (1 << 4) | (1 << 5) | (1 << 8);
		pwm = 2;										// PWM2 Pin 11
		delaySW = 0;
	}

	// RECHTS
	else if (j->direction == xpos)
	{
		out  |= (1 << 4) | (1 << 5) | (1 << 8);
		pwm = 1;										// PWM1 Pin 13
		delaySW = 0;
	}

	// NULLSTELLUNG
	else
	{
		delaySW = 0;
	}
}




/*
static void key3(const struct JOYSTICK* j)
{
	// LINKS
	if (j->direction == xneg)
	{
		out |= (1 << 5) | (1 << 6);
		pwm = 2;										// PWM2 Pin 11
	}

	// RECHTS
	else if (j->direction == xpos)
	{
		out |= (1 << 5) | (1 << 6);
		pwm = 1;										// PWM1 Pin 13
	}
}
*/



static void key5(const struct JOYSTICK* j)
{
	// VOR
	if (j->direction == ypos)
	{
		out |= (1 << 5) | (1 << 6);
		pwm = 2;										// PWM2 Pin 11
	}
	
	// ZURCK
	else if (j->direction == yneg)
	{
		out |= (1 << 5) | (1 << 6);
		pwm = 1;										// PWM1 Pin 13
	}
	
	// LINKS
	if (j->direction == xneg)
	{
		out |= (1 << 7) | (1 << 8);
		pwm = 2;										// PWM2 Pin 11
	}
	
	// RECHTS
	else if (j->direction == xpos)
	{
		out |= (1 << 7) | (1 << 8);
		pwm = 1;										// PWM1 Pin 13
	}
}



/*
//
*/
void program1(const struct JOYSTICK* j, union MSG* msg)
{
	out = 0;
	pwm = 0;

	if (j->keys == 0x00)
	{
		noKeys(j);
	}
	else if (j->keys & TASTE1)
	{
		//
	}
	else if (j->keys & TASTE2)
	{
		//
	}
	else if (j->keys & TASTE3)
	{
		// key3(j);
	}
	else if (j->keys & TASTE4)
	{
		//
	}
	else if (j->keys & TASTE5)
	{
		key5(j);
	}
	else if (j->keys & TASTE6)
	{
		//
	}


	msg->bytes.b0 = out & 0x00FF; 							//(uint8_t)j->keys;
	msg->bytes.b1 = (out & 0xFF00) >> 8;					//(uint8_t)j->direction;
	msg->bytes.pwmOut = pwm;
	msg->bytes.pwmVal = calcPWM();
}
