/*
 * uart.c
 *
 *  Created on: 18.03.2012
 *      Author: Frank
 */
#include "uart.h"
#define UART_RX_BUF 10


static uint8_t rxbuffer[UART_RX_BUF];

//rxIn zeigt auf das erste freie Feld im Lesebuffer
static uint8_t rxIn;
//rxOut zeigt auf das erste beschriebene Feld im Lesebuffer
static uint8_t rxOut;
//static uint8_t txbuffer[UART_RX_BUF];
static uint8_t txIn;
static uint8_t txOut;


ISR(USART_RXC_vect)
{
	rxbuffer[rxIn] = UDR;
	rxIn++;
	if (rxIn >= UART_RX_BUF)
		rxIn = 0;
}


ISR(USART_TXC_vect)
{

}


void init_uart()
{
	/*UART initialisieren*/
	UBRRH = UBR_VAL >> 8;
	UBRRL = UBR_VAL & 0xFF;
	UCSRB |= (1 << TXEN);  // UART TX einschalten
//	UCSRB |= (1 << TXEN) | (1 << RXEN) | (1 << RXCIE);
	UCSRC = (1<<URSEL) | (1<<UCSZ1) | (1<<UCSZ0);  // Asynchron 8N1

	rxIn = rxOut = 0;
	txIn = txOut = 0;

//	for (uint8_t i= 0; i < UART_RX_BUF; ++i)
//			rxbuffer[i] = 0;
}


int uart_putc(unsigned char c)
{
    while (!(UCSRA & (1 << UDRE)))
    {
    }

    UDR = c;
    return 0;
}


void uart_puts (char *s)
{
    while (*s)
    {
    	uart_putc(*s);
        s++;
    }
}
